


		--Remove existing light VMs and their VM record (light VMs with assets are exempted)

		DECLARE @ErrorNo INT,
				@TenantID SMALLINT,
				@OriginalTenantID SMALLINT
				
		SELECT	@ErrorNo = 0
				
		-- Keep the original tenant id
		SELECT	@OriginalTenantID = dbo.GetTenantID()
		
		SELECT @TenantID = MIN(TenantID)
		FROM dbo.Tenant
		
		SELECT @ErrorNo = @@ERROR
		
		WHILE @TenantID IS NOT NULL AND @ErrorNo = 0
		BEGIN

			PRINT 'Removing light virtual machines for Tenant where TenantID = ' + CAST(@TenantID AS NVARCHAR(20))
			-- Set context tenant id so that triggers that reference tenanted view won't result in error
			IF @ErrorNo = 0
			BEGIN
				EXEC SetTenantID @TenantID
				SELECT @ErrorNo = @@ERROR
			END
			
			IF @ErrorNo = 0
			BEGIN
				--Delete the VMs attached to light VMs (i.e. are not inventoried or not manual)
				DELETE vm
				FROM dbo.VirtualMachine vm
					INNER JOIN dbo.ComplianceComputer cc ON cc.ComplianceComputerID = vm.ComplianceComputerID
				WHERE cc.ComplianceComputerInventorySourceTypeID = 2 -- VM host

				-- Delete the light VMs which doesn't have assets, no VM records (those were deleted previously) and not a VM host
				DELETE cc
				FROM dbo.ComplianceComputer cc
					LEFT OUTER JOIN dbo.VirtualMachine vm on vm.ComplianceComputerID = cc.ComplianceComputerID
					LEFT OUTER JOIN dbo.VirtualMachine vh on vh.HostComplianceComputerID = cc.ComplianceComputerID
				WHERE	cc.AssetID IS NULL --No asset
						AND cc.ComplianceComputerInventorySourceTypeID = 2 --VM Host source type
						AND vm.VirtualMachineID IS NULL --No VM records
						AND vh.VirtualMachineID IS NULL --Not a VM Host

				-- Update any light VM with assets to awaiting inventory.
				UPDATE cc
				SET ComplianceComputerStatusID = 4 --Awaiting inventory
				FROM dbo.ComplianceComputer cc
					INNER JOIN dbo.Asset a ON a.AssetID = cc.AssetID
					LEFT OUTER JOIN dbo.VirtualMachine vm on vm.ComplianceComputerID = cc.ComplianceComputerID
					LEFT OUTER JOIN dbo.VirtualMachine vh on vh.HostComplianceComputerID = cc.ComplianceComputerID
				WHERE	cc.ComplianceComputerInventorySourceTypeID = 2 --VM Host source type
						AND vm.VirtualMachineID IS NULL --No VM records
						AND vh.VirtualMachineID IS NULL --Not a VM Host
			END

			IF @ErrorNo = 0
			BEGIN
				-- Get next tenant
				SELECT @TenantID = MIN(TenantID)
				FROM dbo.Tenant
				WHERE TenantID > @TenantID
				SELECT @ErrorNo = @@ERROR
			END
		END

		-- Restore the original tenant id so it won't affect subsequent batch
		EXEC SetTenantID @TenantID=@OriginalTenantID

GO


